Attribute VB_Name = "modPageScroller"
' MSDN Pager
' http://msdn.microsoft.com/en-us/library/bb760857%28VS.85%29.aspx

Option Explicit

Private Const GWL_WNDPROC As Long = -4

' ---=== Window Messages ===---
Private Const WM_NOTIFY As Long = &H4E

' ---=== Window Classes ===---
Private Const WC_PAGESCROLLER As String = "SysPager"

' ---=== Common Controls Classes ===---
Private Const ICC_PAGESCROLLER_CLASS As Long = &H1000

' ---=== Common Control Styles ===---
Private Const CCS_ADJUSTABLE As Long = &H20&
Private Const CCS_TOP As Long = &H1&
Private Const CCS_VERT As Long = &H80&
Private Const CCS_BOTTOM As Long = &H3&
Private Const CCS_NODIVIDER As Long = &H40&
Private Const CCS_NOMOVEY As Long = &H2&
Private Const CCS_NOPARENTALIGN As Long = &H8&
Private Const CCS_NORESIZE As Long = &H4&
Private Const CCS_LEFT As Long = (CCS_VERT Or CCS_TOP)
Private Const CCS_NOMOVEX As Long = (CCS_VERT Or CCS_NOMOVEY)
Private Const CCS_RIGHT As Long = (CCS_VERT Or CCS_BOTTOM)

' ---=== PageScroller Styles ===---
Private Const PGS_AUTOSCROLL As Long = &H2
Private Const PGS_DRAGNDROP As Long = &H4
Private Const PGS_HORZ As Long = &H1
Private Const PGS_VERT As Long = &H0

' ---=== PageScroller Messages ===---
Private Const CCM_FIRST As Long = &H2000
Private Const CCM_GETDROPTARGET As Long = (CCM_FIRST + 4)
Private Const PGM_FIRST As Long = &H1400
Private Const PGM_FORWARDMOUSE As Long = (PGM_FIRST + 3)
Private Const PGM_GETBKCOLOR As Long = (PGM_FIRST + 5)
Private Const PGM_GETBORDER As Long = (PGM_FIRST + 7)
Private Const PGM_GETBUTTONSIZE As Long = (PGM_FIRST + 11)
Private Const PGM_GETBUTTONSTATE As Long = (PGM_FIRST + 12)
Private Const PGM_GETDROPTARGET As Long = CCM_GETDROPTARGET
Private Const PGM_GETPOS As Long = (PGM_FIRST + 9)
Private Const PGM_RECALCSIZE As Long = (PGM_FIRST + 2)
Private Const PGM_SETBKCOLOR As Long = (PGM_FIRST + 4)
Private Const PGM_SETBORDER As Long = (PGM_FIRST + 6)
Private Const PGM_SETBUTTONSIZE As Long = (PGM_FIRST + 10)
Private Const PGM_SETCHILD As Long = (PGM_FIRST + 1)
Private Const PGM_SETPOS As Long = (PGM_FIRST + 8)

' ---=== PageScroller Notifications ===---
Private Const PGN_FIRST As Long = (-900)
Private Const PGN_CALCSIZE As Long = (PGN_FIRST - 2)
Private Const PGN_HOTITEMCHANGE As Long = (PGN_FIRST - 3)
Private Const PGN_SCROLL As Long = (PGN_FIRST - 1)
Private Const NM_FIRST As Long = 0
Private Const NM_RELEASEDCAPTURE As Long = (NM_FIRST - 16)

' ---=== PageScroller NMPGCALCSIZE.dwFlag Flag ===---
Private Const PGF_CALCHEIGHT As Long = 2
Private Const PGF_CALCWIDTH As Long = 1

' ---=== PageScroller NMPGSCROLL.fwKeys Flag ===---
Private Const PGK_CONTROL As Long = 2
Private Const PGK_MENU As Long = 4
Private Const PGK_SHIFT As Long = 1

' ---=== PageScroller NMPGSCROLL.iDir Flag ===---
Private Const PGF_SCROLLDOWN As Long = 2
Private Const PGF_SCROLLLEFT As Long = 4
Private Const PGF_SCROLLRIGHT As Long = 8
Private Const PGF_SCROLLUP As Long = 1

' ---=== PageScroller PGM_GETBUTTONSTATE lParam ===---
Private Const PGB_BOTTOMORRIGHT As Long = 1
Private Const PGB_TOPORLEFT As Long = 0

' ---=== PageScroller PGM_GETBUTTONSTATE ===---
Private Const PGF_DEPRESSED As Long = 4
Private Const PGF_GRAYED As Long = 2
Private Const PGF_HOT As Long = 8
Private Const PGF_INVISIBLE As Long = 0
Private Const PGF_NORMAL As Long = 1

' ---=== PageScroller NMPGHOTITEM.dwFlags Flag ===---
' erst ab Windows XP mit aktiviertem Visual Style
Private Const HICF_ENTERING As Long = &H10
Private Const HICF_LEAVING As Long = &H20

' ---=== Window Styles ===---
Private Const WS_CHILD As Long = &H40000000
Private Const WS_CLIPCHILDREN As Long = &H2000000
Private Const WS_CLIPSIBLINGS As Long = &H4000000
Private Const WS_TABSTOP As Long = &H10000
Private Const WS_VISIBLE As Long = &H10000000

' ---=== InitCommonControlsEx Type ===---
Private Type InitCommonControlsEx
    dwSize As Long
    dwICC As Long
End Type

' ---=== div. Type ===---
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

' ---=== Notification Header Type ===---
Private Type NMHDR
    hwndFrom As Long
    idFrom As Long
    Code As Long
End Type

' ---=== Notification PGN_CALCSIZE Type ===---
Private Type NMPGCALCSIZE
    hdr As NMHDR
    dwFlag As Long
    iWidth As Long
    iHeight As Long
End Type

' ---=== Notification PGN_HOTITEMCHANGE Type ===---
' erst ab Windows XP mit aktiviertem Visual Style
Private Type NMPGHOTITEM
    hdr As NMHDR
    idOld As Long
    idNew As Long
    dwFlags As Long
End Type

' ---=== Notification PGN_SCROLL Type ===---
' NMPGSCROLL kann in VB nicht direkt verwendet werden
Private Type NMPGSCROLL
    hdr As NMHDR
    fwKeys As Integer
    rcParent As RECT
    iDir As Long
    iXpos As Long
    iYpos As Long
    iScroll As Long
End Type

Private Type NMPGSCROLL1
    hdr As NMHDR
    fwKeys As Integer
End Type

Private Type NMPGSCROLL2
    rcParent As RECT
    iDir As Long
    iXpos As Long
    iYpos As Long
    iScroll As Long
End Type

' ---=== USER32 Deklaration ===---
Private Declare Function CallWindowProc Lib "user32.dll" _
                         Alias "CallWindowProcA" ( _
                         ByVal lpPrevWndFunc As Long, _
                         ByVal hwnd As Long, _
                         ByVal Msg As Long, _
                         ByVal wParam As Long, _
                         ByVal lParam As Long) As Long
                         
Private Declare Function GetClientRect Lib "user32.dll" ( _
                         ByVal hwnd As Long, _
                         ByRef lpRect As RECT) As Long
                         
Private Declare Function SetWindowLong Lib "user32.dll" _
                         Alias "SetWindowLongA" ( _
                         ByVal hwnd As Long, _
                         ByVal nIndex As Long, _
                         ByVal dwNewLong As Long) As Long
                         
' ---=== COMCTL32 Deklaration ===---
Private Declare Function InitCommonControlsEx Lib "comctl32.dll" ( _
                         ByRef TLPINITCOMMONCONTROLSEX As InitCommonControlsEx) As Long
                         
' ---=== KERNEL32 Deklaration ===---
Private Declare Sub CopyMemory Lib "kernel32.dll" _
                    Alias "RtlMoveMemory" ( _
                    ByRef Destination As Any, _
                    ByRef Source As Any, _
                    ByVal Length As Long)
                    
Private Declare Function FreeLibrary Lib "kernel32.dll" ( _
                         ByVal hLibModule As Long) As Long
                         
Private Declare Function GetProcAddress Lib "kernel32.dll" ( _
                         ByVal hModule As Long, _
                         ByVal lpProcName As String) As Long
                         
Private Declare Function LoadLibrary Lib "kernel32.dll" _
                         Alias "LoadLibraryA" ( _
                         ByVal lpLibFileName As String) As Long
                         
' ---=== USER32 Deklaration ===---
Private Declare Function CreateWindowEx Lib "user32.dll" _
                         Alias "CreateWindowExA" ( _
                         ByVal dwExStyle As Long, _
                         ByVal lpClassName As String, _
                         ByVal lpWindowName As String, _
                         ByVal dwStyle As Long, _
                         ByVal x As Long, _
                         ByVal y As Long, _
                         ByVal nWidth As Long, _
                         ByVal nHeight As Long, _
                         ByVal hWndParent As Long, _
                         ByVal hMenu As Long, _
                         ByVal hInstance As Long, _
                         ByRef lpParam As Any) As Long
                         
Private Declare Function DestroyWindow Lib "user32.dll" ( _
                         ByVal hwnd As Long) As Long
                         
Private Declare Function GetParent Lib "user32.dll" ( _
                         ByVal hwnd As Long) As Long
                         
Private Declare Function MoveWindow Lib "user32.dll" ( _
                         ByVal hwnd As Long, _
                         ByVal x As Long, _
                         ByVal y As Long, _
                         ByVal nWidth As Long, _
                         ByVal nHeight As Long, _
                         ByVal bRepaint As Long) As Long
                         
Private Declare Function SendMessage Lib "user32.dll" _
                         Alias "SendMessageA" ( _
                         ByVal hwnd As Long, _
                         ByVal wMsg As Long, _
                         ByVal wParam As Long, _
                         ByRef lParam As Any) As Long
                         
Private Declare Function SetParent Lib "user32.dll" ( _
                         ByVal hWndChild As Long, _
                         ByVal hWndNewParent As Long) As Long
                         
' ---=== Variablen ===---
Private hFrmWnd As Long
Private hPagerWnd As Long
Private hChildWnd As Long
Private hChildParentWnd As Long
Private lngStyle As Long
Private lngWndProc As Long
Private lngChildWidth As Long
Private lngChildHeight As Long
Private tNMHDR As NMHDR
Private tNMPGSCROLL1 As NMPGSCROLL1
Private tNMPGSCROLL2 As NMPGSCROLL2
Private tNMPGHOTITEM As NMPGHOTITEM
Private tNMPGCALCSIZE As NMPGCALCSIZE

Public Function CratePageScroller(ByRef Frm As Form, ByVal Left As Long, ByVal Top _
    As Long, ByVal Width As Long, ByVal Height As Long, ByVal ChildWnd As Long) As Boolean
    
    Dim hLib As Long
    Dim lngProcAddress As Long
    Dim tICCEx As InitCommonControlsEx
    
    ' Fensterhandle der Form speichern
    hFrmWnd = Frm.hwnd
    
    ' Subclassing starten
    lngWndProc = SetWindowLong(hFrmWnd, GWL_WNDPROC, AddressOf WindowProc)
    
    ' Luft das Subclassing
    If lngWndProc <> 0 Then
    
        ' COMCTL32.DLL laden
        hLib = LoadLibrary("comctl32.dll")
        
        ' ist ein Handle auf die DLL vorhanden
        If hLib <> 0 Then
        
            ' Handle auf "InitCommonControlsEx" holen
            lngProcAddress = GetProcAddress(hLib, "InitCommonControlsEx")
            
            ' ist ein Handle auf "InitCommonControlsEx" vorhanden
            If lngProcAddress <> 0 Then
            
                ' Struktur InitCommonControlsEx initialisieren
                With tICCEx
                
                    .dwSize = Len(tICCEx)
                    .dwICC = ICC_PAGESCROLLER_CLASS
                    
                End With
                
                ' PageScroller initialisieren
                If InitCommonControlsEx(tICCEx) <> 0 Then
                
                    ' PagerScroller-Fentser erstellen
                    hPagerWnd = CreateWindowEx(0&, WC_PAGESCROLLER, vbNullString, _
                        WS_CHILD Or WS_CLIPCHILDREN Or WS_CLIPSIBLINGS Or _
                        WS_TABSTOP Or WS_VISIBLE Or PGS_HORZ Or CCS_NORESIZE, Left, _
                        Top, Width, Height, hFrmWnd, 0&, App.hInstance, ByVal 0&)
                        
                    ' ist ein Fensterhandle vorhanden
                    If hPagerWnd <> 0 Then
                        
                        Call SetPageScrollerChild(ChildWnd)
                        
                        CratePageScroller = True
                        
                    End If
                End If
            End If
            
            ' COMCTL32.DLL freigeben
            Call FreeLibrary(hLib)
            
        End If
    End If
    
End Function

Public Sub DestroyPageScroller()

    ' ist ein Fensterhandle vorhanden
    If hChildWnd <> 0 Then
    
        ' Childfenster wieder an das ursprngliche Fenster zurck setzen
        Call SetParent(hChildWnd, hChildParentWnd)
        
    End If
    
    ' ist ein Fensterhandle vorhanden
    If hPagerWnd <> 0 Then
    
        ' Fenster zerstren
        Call DestroyWindow(hPagerWnd)
        
    End If
    
    ' Subclassing beenden
    Call SetWindowLong(hFrmWnd, GWL_WNDPROC, lngWndProc)
    
End Sub

Public Sub ForwardMousePageScroller(ByVal Enable As Boolean)

    If hChildWnd <> 0 Then
    
        Call SendMessage(hPagerWnd, PGM_FORWARDMOUSE, Enable, ByVal 0&)
        
    End If
    
End Sub

Public Function GetPageScrollerButtonBackColor() As Long

    If hPagerWnd <> 0 Then
    
        GetPageScrollerButtonBackColor = SendMessage(hPagerWnd, PGM_GETBKCOLOR, 0&, _
            ByVal 0&)
            
    End If
    
End Function

Public Function GetPageScrollerBorderSize() As Long

    If hPagerWnd <> 0 Then
    
        GetPageScrollerBorderSize = SendMessage(hPagerWnd, PGM_GETBORDER, 0&, ByVal _
            0&)
            
    End If
    
End Function

Public Function GetPageScrollerButtonSize() As Long

    If hPagerWnd <> 0 Then
    
        GetPageScrollerButtonSize = SendMessage(hPagerWnd, PGM_GETBUTTONSIZE, 0&, _
            ByVal 0&)
            
    End If
    
End Function

Public Function GetPageScrollerButtonState(ByVal PageScrollerButton As Long) As Long

    If hPagerWnd <> 0 Then
    
        GetPageScrollerButtonState = SendMessage(hPagerWnd, PGM_GETBUTTONSTATE, 0&, _
            ByVal PageScrollerButton)
            
    End If
    
End Function

Public Function GetPageScrollerScrollPos() As Long

    If hPagerWnd <> 0 Then
    
        GetPageScrollerScrollPos = SendMessage(hPagerWnd, PGM_GETPOS, 0&, ByVal 0&)
        
    End If
    
End Function

Public Sub ReCalcSizePageScroller()

    If hChildWnd <> 0 Then
    
        Call SendMessage(hPagerWnd, PGM_RECALCSIZE, 0&, ByVal 0&)
        
    End If
    
End Sub

Public Sub SetPageScrollerButtonBackColor(ByVal Color As Long)

    If hPagerWnd <> 0 Then
    
        Call SendMessage(hPagerWnd, PGM_SETBKCOLOR, 0&, ByVal Color)
        
    End If
    
End Sub

Public Sub SetPageScrollerBorderSize(ByVal BorderSize As Long)

    If hPagerWnd <> 0 Then
    
        Call SendMessage(hPagerWnd, PGM_SETBORDER, 0&, ByVal BorderSize)
        
    End If
    
End Sub

Public Sub SetPageScrollerButtonSize(ByVal ButtonSize As Long)

    If hPagerWnd <> 0 Then
    
        Call SendMessage(hPagerWnd, PGM_SETBUTTONSIZE, 0&, ByVal ButtonSize)
        
    End If
    
End Sub

Private Sub SetPageScrollerChild(ByVal ChildWnd As Long)

    Dim tRECT As RECT
    
    If hPagerWnd <> 0 Then
        If ChildWnd <> 0 Then
        
            hChildWnd = ChildWnd
            hChildParentWnd = GetParent(hChildWnd)
            
            If hChildParentWnd <> 0 Then
                If GetClientRect(hChildWnd, tRECT) <> 0 Then
                
                    lngChildWidth = tRECT.Right
                    lngChildHeight = tRECT.Bottom
                    
                    If SetParent(hChildWnd, hPagerWnd) <> 0 Then
                    
                        Call SendMessage(hPagerWnd, PGM_SETCHILD, 0&, ByVal ChildWnd)
                        
                    End If
                End If
            End If
        End If
    End If
    
End Sub

Public Sub SetPageScrollerScrollPos(ByVal ScrollPos As Long)

    If hPagerWnd <> 0 Then
    
        Call SendMessage(hPagerWnd, PGM_SETPOS, 0&, ByVal ScrollPos)
        
    End If
    
End Sub

Private Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As _
    Long, ByVal lParam As Long) As Long
    
    ' nur wenn die Nachricht WM_NOTIFY eintrifft
    If uMsg = WM_NOTIFY Then
    
        ' steht ein Wert in lParam
        If lParam <> 0 Then
        
            ' NotifyMessageHeader auslesen
            Call CopyMemory(tNMHDR, ByVal lParam, Len(tNMHDR))
            
            ' ist die Nachricht fr den erstellten SysPager
            If tNMHDR.hwndFrom = hPagerWnd Then
            
                ' welche Nachricht fr den SysPager ist eingetroffen
                Select Case tNMHDR.Code
                
                Case PGN_SCROLL
                
                    Call CopyMemory(tNMPGSCROLL1, ByVal lParam, Len(tNMPGSCROLL1))
                    Call CopyMemory(tNMPGSCROLL2, ByVal lParam + Len(tNMPGSCROLL1), Len(tNMPGSCROLL2))
                    
                    Select Case tNMPGSCROLL1.fwKeys
                    
                    Case PGK_SHIFT
                        Debug.Print "Shift Key pressed"
                        
                    Case PGK_CONTROL
                        Debug.Print "Control Key pressed"
                        
                    Case PGK_MENU
                        Debug.Print "ALT Key pressed"
                        
                    End Select
                    
                    Debug.Print "ClientLeft = " & CStr(tNMPGSCROLL2.rcParent.Left)
                    Debug.Print "ClientTop = " & CStr(tNMPGSCROLL2.rcParent.Top)
                    Debug.Print "ClientRight = " & CStr(tNMPGSCROLL2.rcParent.Right)
                    Debug.Print "ClientBottom = " & CStr(tNMPGSCROLL2.rcParent.Bottom)

                    Select Case tNMPGSCROLL2.iDir

                    Case PGF_SCROLLLEFT
                        Debug.Print "Left Button pressed"

                    Case PGF_SCROLLRIGHT
                        Debug.Print "Right Button pressed"
                        
                    Case PGF_SCROLLUP
                        Debug.Print "Up Button pressed"

                    Case PGF_SCROLLDOWN
                        Debug.Print "Down Button pressed"

                    End Select

                    Debug.Print "iXpos = " & CStr(tNMPGSCROLL2.iXpos)
                    Debug.Print "iYpos = " & CStr(tNMPGSCROLL2.iYpos)

                    ' iScroll (Wert der vom SysPager selbst berechnet wird)
                    Debug.Print "iScroll = " & CStr(tNMPGSCROLL2.iScroll)

                    ' modify scroll delta
                    tNMPGSCROLL2.iScroll = 5
                    
                    Call CopyMemory(ByVal lParam, tNMPGSCROLL1, Len(tNMPGSCROLL1))
                    Call CopyMemory(ByVal lParam + Len(tNMPGSCROLL1), tNMPGSCROLL2, Len(tNMPGSCROLL2))
                    
                Case PGN_CALCSIZE
                
                    Call CopyMemory(tNMPGCALCSIZE, ByVal lParam, Len(tNMPGCALCSIZE))
                    
                    Select Case tNMPGCALCSIZE.dwFlag
                    
                    Case PGF_CALCWIDTH
                        tNMPGCALCSIZE.iWidth = lngChildWidth
                        
                    Case PGF_CALCHEIGHT
                        tNMPGCALCSIZE.iHeight = lngChildHeight
                        
                    End Select
                    
                    Call CopyMemory(ByVal lParam, tNMPGCALCSIZE, Len(tNMPGCALCSIZE))
                    
                Case PGN_HOTITEMCHANGE
                
                    Call CopyMemory(tNMPGHOTITEM, ByVal lParam, Len(tNMPGHOTITEM))
                    
                    ' Info: erst ab Windows XP mit aktiviertem Visual Style

                    Call CopyMemory(ByVal lParam, tNMPGHOTITEM, Len(tNMPGHOTITEM))
                    
                Case NM_RELEASEDCAPTURE
                
                End Select
                
                WindowProc = 0&
                
                Exit Function
                
            End If
        End If
    End If
    
    ' alle anderen Nachrichten weiterleiten
    WindowProc = CallWindowProc(lngWndProc, hwnd, uMsg, wParam, lParam)
    
End Function
